#ifndef USAGEPREDICTOR_HPP_
#define USAGEPREDICTOR_HPP_

#include "ClusteringAlgorithm.hpp"
#include "DataCollector.hpp"
#include "ClusterAnalyzer.hpp"

using namespace std;

class UsagePredictor { 
public:

	UsagePredictor (ClusteringAlgorithm *clAlgorithm, DataCollector *dtCollector);
	//float minCpuRequired = 0.5f, long minMemoryRequired = 10240
	bool canRunGridApplication(Timestamp timestamp, ResourceData rd, int hours = DEFAULT_PREDICTION_HOURS);
   bool canRunGridApplication2(Timestamp timestamp, ResourceData rd, int hours = DEFAULT_PREDICTION_HOURS);
	bool canRunGridApplication(Timestamp timestamp, ResourceData rd, UsageData *recentDataSample, int hours);
   bool canRunGridApplication2(Timestamp timestamp, ResourceData rd, UsageData *recentDataSample, int hours);
	vector<double> getPrediction(Timestamp timestamp, resource r, int hours, UsageData *recentDataSample);
	vector<double> getPrediction(Timestamp timestamp, resource r, int hours);
		
   int howLongCanRunGridApplication(Timestamp timestamp, ResourceData rd, UsageData *recentDataSample);
   double* averageResourceUsage(Timestamp timestamp, ResourceData rd, int hours, UsageData *recentDataSample);

private:
	ClusterAnalyzer *clusterAnalyzer;	
	DataCollector *dataCollector;

   double averageResourceValue(Timestamp timestamp, resource r, double minimum, int hours, UsageData *recentDataSample);
   void shiftUsageDataByOffset(UsageData *usageData, double resourceOffset, resource r);

   
};

#endif /*USAGEPREDICTOR_HPP_*/
